Module javafx.controls
Package javafx.scene.control.skin

# Class TableViewSkinBase<M,S,C extends Control,I extends IndexedCell<M>,TC extends TableColumnBase<S,?>>

java.lang.Object
javafx.scene.control.SkinBase<C>
javafx.scene.control.skin.VirtualContainerBase<C,I>
javafx.scene.control.skin.TableViewSkinBase<M,S,C,I,TC>

Type Parameters:
  `M` - The type of the item stored in each row (for TableView, this is the type of the items list, and for TreeTableView, this is the type of the TreeItem).
  `S` - The type of the item, as represented by the selection model (for TableView, this is, again, the type of the items list, and for TreeTableView, this is TreeItem typed to the same type as M).
  `C` - The type of the virtualised control (e.g TableView, TreeTableView)
  `I` - The type of cell used by this virtualised control (e.g. TableRow, TreeTableRow)
  `TC` - The type of TableColumnBase used by this virtualised control (e.g. TableColumn, TreeTableColumn)

All Implemented Interfaces:
  `Skin<C>`

Direct Known Subclasses:
  `TableViewSkin`, `TreeTableViewSkin`

public abstract class TableViewSkinBase<M,S,C extends Control,I extends IndexedCell<M>,TC extends TableColumnBase<S,?>> extends VirtualContainerBase<C,I>
TableViewSkinBase is the base skin class used by controls such as `TableView` and `TreeTableView` (the concrete classes are `TableViewSkin` and `TreeTableViewSkin`, respectively).

Since:
  9
See Also:
  - `TableView`
  - `TreeTableView`
  - `TableViewSkin`
  - `TreeTableViewSkin`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TableViewSkinBase(C control)`
  Constructs a `TableViewSkinBase` for the given control.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected TableHeaderRow`
  `createTableHeaderRow()`
  Creates a new TableHeaderRow instance.
  `protected TableHeaderRow`
  `getTableHeaderRow()`
  Returns the `TableHeaderRow` created using `createTableHeaderRow()`.
  `protected void`
  `onFocusAboveCell()`
  Called when the focus is set on the cell above the current focused cell in order to scroll to it to make it visible.
  `protected void`
  `onFocusBelowCell()`
  Called when the focus is set on the cell below the current focused cell in order to scroll to it to make it visible.
  `protected void`
  `onFocusLeftCell()`
  Called when the focus is set on the left cell of the current selected one in order to horizontally scroll to it to make it visible.
  `protected void`
  `onFocusRightCell()`
  Called when the focus is set on the right cell of the current selected one in order to horizontally scroll to it to make it visible.
  `protected void`
  `onMoveToFirstCell()`
  Called when the selection is set on the first cell of the table (first row and first column) in order to scroll to it to make it visible.
  `protected void`
  `onMoveToLastCell()`
  Called when the selection is set on the last cell of the table (last row and last column) in order to scroll to it to make it visible.
  `protected int`
  `onScrollPageDown(boolean isFocusDriven)`
  Returns the index of the selected (or focused, if `isFocusDriven` is `true`) cell after a page scroll operation.
  `protected int`
  `onScrollPageUp(boolean isFocusDriven)`
  Returns the index of the selected (or focused, if `isFocusDriven` is `true`) cell after a page scroll operation.
  `protected void`
  `onSelectAboveCell()`
  Called when the selection is set on the the cell above the current focused cell in order to scroll to it to make it visible.
  `protected void`
  `onSelectBelowCell()`
  Called when the selection is set on the cell below the current focused cell in order to scroll to it to make it visible.
  `protected void`
  `onSelectLeftCell()`
  Called when the selection is set on the left cell of the current selected one in order to horizontally scroll to it to make it visible.
  `protected void`
  `onSelectRightCell()`
  Called when the selection is set on the right cell of the current selected one in order to horizontally scroll to it to make it visible.
  `void`
  `scrollHorizontally()`
  Scrolls to the column containing the current focused cell.
  `protected void`
  `scrollHorizontally(TC col)`
  Programmatically scrolls to the given column.
  `protected void`
  `updateItemCount()`
  This method is called when it is possible that the item count has changed (i.e.

  ### Methods declared in class javafx.scene.control.skin.VirtualContainerBase

  `createVirtualFlow, dispose, getItemCount, getVirtualFlow, markItemCountDirty`

  ### Methods declared in class javafx.scene.control.SkinBase

  `computeBaselineOffset, computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, consumeMouseEvents, executeAccessibleAction, getChildren, getClassCssMetaData, getCssMetaData, getNode, getSkinnable, layoutChildren, layoutInArea, layoutInArea, layoutInArea, positionInArea, positionInArea, pseudoClassStateChanged, queryAccessibleAttribute, registerChangeListener, registerInvalidationListener, registerListChangeListener, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, unregisterChangeListeners, unregisterInvalidationListeners, unregisterListChangeListeners`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods declared in interface javafx.scene.control.Skin

  `install`

- ## Constructor Details

  - ### TableViewSkinBase

    public TableViewSkinBase(C control)
    Constructs a `TableViewSkinBase` for the given control.
    Parameters:
      `control` - the control

- ## Method Details

  - ### createTableHeaderRow

    protected TableHeaderRow createTableHeaderRow()
    Creates a new TableHeaderRow instance. By default this method should not be overridden, but in some circumstances it makes sense (e.g. testing, or when extreme customization is desired).
    Returns:
      A new TableHeaderRow instance.

  - ### getTableHeaderRow

    protected TableHeaderRow getTableHeaderRow()
    Returns the `TableHeaderRow` created using `createTableHeaderRow()`.
    Returns:
      the `TableHeaderRow` for this `TableViewSkinBase`
    Since:
      12

  - ### updateItemCount

    protected void updateItemCount()
    This method is called when it is possible that the item count has changed (i.e. scrolling has occurred, the control has resized, etc). This method should recalculate the item count and store that for future use by the `VirtualContainerBase.getItemCount()` method.
    Specified by:
      `updateItemCount` in class `VirtualContainerBase<C extends Control,I extends IndexedCell<M>>`

  - ### onFocusAboveCell

    protected void onFocusAboveCell()
    Called when the focus is set on the cell above the current focused cell in order to scroll to it to make it visible.
    Since:
      12

  - ### onFocusBelowCell

    protected void onFocusBelowCell()
    Called when the focus is set on the cell below the current focused cell in order to scroll to it to make it visible.
    Since:
      12

  - ### onSelectAboveCell

    protected void onSelectAboveCell()
    Called when the selection is set on the the cell above the current focused cell in order to scroll to it to make it visible.
    Since:
      12

  - ### onSelectBelowCell

    protected void onSelectBelowCell()
    Called when the selection is set on the cell below the current focused cell in order to scroll to it to make it visible.
    Since:
      12

  - ### onSelectLeftCell

    protected void onSelectLeftCell()
    Called when the selection is set on the left cell of the current selected one in order to horizontally scroll to it to make it visible.
    Since:
      12

  - ### onSelectRightCell

    protected void onSelectRightCell()
    Called when the selection is set on the right cell of the current selected one in order to horizontally scroll to it to make it visible.
    Since:
      12

  - ### onFocusLeftCell

    protected void onFocusLeftCell()
    Called when the focus is set on the left cell of the current selected one in order to horizontally scroll to it to make it visible.
    Since:
      12

  - ### onFocusRightCell

    protected void onFocusRightCell()
    Called when the focus is set on the right cell of the current selected one in order to horizontally scroll to it to make it visible.
    Since:
      12

  - ### onMoveToFirstCell

    protected void onMoveToFirstCell()
    Called when the selection is set on the first cell of the table (first row and first column) in order to scroll to it to make it visible.
    Since:
      12

  - ### onMoveToLastCell

    protected void onMoveToLastCell()
    Called when the selection is set on the last cell of the table (last row and last column) in order to scroll to it to make it visible.
    Since:
      12

  - ### onScrollPageDown

    protected int onScrollPageDown(boolean isFocusDriven)
    Returns the index of the selected (or focused, if `isFocusDriven` is `true`) cell after a page scroll operation. If the selected/focused cell is not the last fully visible cell, then the last fully visible cell is selected/focused. Otherwise, the content is scrolled such that the cell is made visible at the top of the viewport (and the new last fully visible cell is selected/focused instead).
    Parameters:
      `isFocusDriven` - `true` if focused cell should be considered over selection
    Returns:
      the new index to select, or to focus if `isFocusDriven` is `true`
    Since:
      12

  - ### onScrollPageUp

    protected int onScrollPageUp(boolean isFocusDriven)
    Returns the index of the selected (or focused, if `isFocusDriven` is `true`) cell after a page scroll operation. If the selected/focused cell is not the first fully visible cell, then the first fully visible cell is selected/focused. Otherwise, the content is scrolled such that the cell is made visible at the bottom of the viewport (and the new first fully visible cell is selected/focused instead).
    Parameters:
      `isFocusDriven` - `true` if focused cell should be considered over selection
    Returns:
      the new index to select, or to focus if `isFocusDriven` is `true`
    Since:
      12

  - ### scrollHorizontally

    public void scrollHorizontally()
    Scrolls to the column containing the current focused cell.

    Handles the horizontal scrolling when the selection mode is cell-based and the newly selected cell belongs to a column which is not completely visible.

    Since:
      12

  - ### scrollHorizontally

    protected void scrollHorizontally(TC col)
    Programmatically scrolls to the given column. This call will ensure that the column is aligned on the left edge of the `TableView` and also that the columns don't become detached from the right edge of the table.
    Parameters:
      `col` - the column to scroll to
    Since:
      12